org.optaplanner.core.impl.domain.variable.anchor

## Class ExternalizedAnchorVariableSupply

- java.lang.Object
- - org.optaplanner.core.impl.domain.variable.anchor.ExternalizedAnchorVariableSupply

- All Implemented Interfaces:
    Closeable, AutoCloseable, VariableListener<Object>, AnchorVariableSupply, SourcedVariableListener<Object>, StatefulVariableListener<Object>, Supply

      public class ExternalizedAnchorVariableSupply
      extends Object
      implements SourcedVariableListener<Object>, AnchorVariableSupply

  Alternative to `AnchorVariableListener`.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Map<Object,Object>` | `anchorMap`
    `protected SingletonInverseVariableSupply` | `nextVariableSupply`
    `protected VariableDescriptor` | `previousVariableDescriptor`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExternalizedAnchorVariableSupply(VariableDescriptor previousVariableDescriptor, SingletonInverseVariableSupply nextVariableSupply)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterEntityAdded(ScoreDirector scoreDirector, Object entity)`
    `void` | `afterEntityRemoved(ScoreDirector scoreDirector, Object entity)`
    `void` | `afterVariableChanged(ScoreDirector scoreDirector, Object entity)`
    `void` | `beforeEntityAdded(ScoreDirector scoreDirector, Object entity)`
    `void` | `beforeEntityRemoved(ScoreDirector scoreDirector, Object entity)`
    `void` | `beforeVariableChanged(ScoreDirector scoreDirector, Object entity)`
    `void` | `clearWorkingSolution(ScoreDirector scoreDirector)`
    `Object` | `getAnchor(Object entity)`
    `VariableDescriptor` | `getSourceVariableDescriptor()`
    `protected void` | `insert(ScoreDirector scoreDirector, Object entity)`
    `void` | `resetWorkingSolution(ScoreDirector scoreDirector)` Called when the entire working solution changes.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.domain.variable.listener.VariableListener

      `requiresUniqueEntityEvents`

    - ### Methods inherited from interface org.optaplanner.core.api.domain.variable.VariableListener

      `close`

- - ### Field Detail

    - #### previousVariableDescriptor

          protected final VariableDescriptor previousVariableDescriptor

    - #### nextVariableSupply

          protected final SingletonInverseVariableSupply nextVariableSupply

    - #### anchorMap

          protected Map<Object,Object> anchorMap

  - ### Constructor Detail

    - #### ExternalizedAnchorVariableSupply

          public ExternalizedAnchorVariableSupply(VariableDescriptor previousVariableDescriptor,
                                                  SingletonInverseVariableSupply nextVariableSupply)

  - ### Method Detail

    - #### getSourceVariableDescriptor

          public VariableDescriptor getSourceVariableDescriptor()

      Specified by:
        `getSourceVariableDescriptor` in interface `SourcedVariableListener<Object>`
      Specified by:
        `getSourceVariableDescriptor` in interface `StatefulVariableListener<Object>`

    - #### resetWorkingSolution

          public void resetWorkingSolution(ScoreDirector scoreDirector)

      Description copied from interface: `VariableListener`
      Called when the entire working solution changes. In this event, the other before..()/after...() methods will not be called. At this point, implementations should clear state, if any.
      Specified by:
        `resetWorkingSolution` in interface `VariableListener<Object>`
      Specified by:
        `resetWorkingSolution` in interface `StatefulVariableListener<Object>`
      Parameters:
        `scoreDirector` - never null

    - #### clearWorkingSolution

          public void clearWorkingSolution(ScoreDirector scoreDirector)

      Specified by:
        `clearWorkingSolution` in interface `StatefulVariableListener<Object>`

    - #### beforeEntityAdded

          public void beforeEntityAdded(ScoreDirector scoreDirector,
                                        Object entity)

      Specified by:
        `beforeEntityAdded` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### afterEntityAdded

          public void afterEntityAdded(ScoreDirector scoreDirector,
                                       Object entity)

      Specified by:
        `afterEntityAdded` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### beforeVariableChanged

          public void beforeVariableChanged(ScoreDirector scoreDirector,
                                            Object entity)

      Specified by:
        `beforeVariableChanged` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### afterVariableChanged

          public void afterVariableChanged(ScoreDirector scoreDirector,
                                           Object entity)

      Specified by:
        `afterVariableChanged` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### beforeEntityRemoved

          public void beforeEntityRemoved(ScoreDirector scoreDirector,
                                          Object entity)

      Specified by:
        `beforeEntityRemoved` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### afterEntityRemoved

          public void afterEntityRemoved(ScoreDirector scoreDirector,
                                         Object entity)

      Specified by:
        `afterEntityRemoved` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### insert

          protected void insert(ScoreDirector scoreDirector,
                                Object entity)

    - #### getAnchor

          public Object getAnchor(Object entity)

      Specified by:
        `getAnchor` in interface `AnchorVariableSupply`
      Parameters:
        `entity` - never null
      Returns:
        sometimes null, the anchor for the entity

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2006–2021 JBoss by Red Hat. All rights reserved.